<?php
if ( ! class_exists( 'Plumbing_Contractor_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * Plumbing_Contractor_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class Plumbing_Contractor_Plugin_Activation_WPElemento_Importer {

        private static $plumbing_contractor_instance;
        public $plumbing_contractor_action_count;
        public $plumbing_contractor_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$plumbing_contractor_instance) ) {
            self::$plumbing_contractor_instance = new self();
          }
          return self::$plumbing_contractor_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'plumbing_contractor_recommended_plugins', array($this, 'plumbing_contractor_recommended_elemento_importer_plugins_array') );

            $plumbing_contractor_actions                   = $this->plumbing_contractor_get_recommended_actions();
            $this->plumbing_contractor_action_count        = $plumbing_contractor_actions['count'];
            $this->plumbing_contractor_recommended_actions = $plumbing_contractor_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function plumbing_contractor_recommended_elemento_importer_plugins_array($plumbing_contractor_plugins){
            $plumbing_contractor_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'plumbing-contractor'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'plumbing-contractor'),               
            );
            return $plumbing_contractor_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'plumbing-contractor-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('plumbing-contractor-plugin-activation-script', 'plumbing_contractor_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'plumbing-contractor'),
                    'activating' => esc_html__('Activating', 'plumbing-contractor'),
                    'error' => esc_html__('Error', 'plumbing-contractor'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'plumbing-contractor-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function plumbing_contractor_get_recommended_actions() {

            $plumbing_contractor_act_count  = 0;
            $plumbing_contractor_actions_todo = get_option( 'recommending_actions', array());

            $plumbing_contractor_plugins = $this->plumbing_contractor_get_recommended_plugins();

            if ($plumbing_contractor_plugins) {
                foreach ($plumbing_contractor_plugins as $plumbing_contractor_key => $plumbing_contractor_plugin) {
                    $plumbing_contractor_action = array();
                    if (!isset($plumbing_contractor_plugin['slug'])) {
                        continue;
                    }

                    $plumbing_contractor_action['id']   = 'install_' . $plumbing_contractor_plugin['slug'];
                    $plumbing_contractor_action['desc'] = '';
                    if (isset($plumbing_contractor_plugin['desc'])) {
                        $plumbing_contractor_action['desc'] = $plumbing_contractor_plugin['desc'];
                    }

                    $plumbing_contractor_action['name'] = '';
                    if (isset($plumbing_contractor_plugin['name'])) {
                        $plumbing_contractor_action['title'] = $plumbing_contractor_plugin['name'];
                    }

                    $plumbing_contractor_link_and_is_done  = $this->plumbing_contractor_get_plugin_buttion($plumbing_contractor_plugin['slug'], $plumbing_contractor_plugin['name'], $plumbing_contractor_plugin['function']);
                    $plumbing_contractor_action['link']    = $plumbing_contractor_link_and_is_done['button'];
                    $plumbing_contractor_action['is_done'] = $plumbing_contractor_link_and_is_done['done'];
                    if (!$plumbing_contractor_action['is_done'] && (!isset($plumbing_contractor_actions_todo[$plumbing_contractor_action['id']]) || !$plumbing_contractor_actions_todo[$plumbing_contractor_action['id']])) {
                        $plumbing_contractor_act_count++;
                    }
                    $plumbing_contractor_recommended_actions[] = $plumbing_contractor_action;
                    $plumbing_contractor_actions_todo[]        = array('id' => $plumbing_contractor_action['id'], 'watch' => true);
                }
                return array('count' => $plumbing_contractor_act_count, 'actions' => $plumbing_contractor_recommended_actions);
            }

        }

        public function plumbing_contractor_get_recommended_plugins() {

            $plumbing_contractor_plugins = apply_filters('plumbing_contractor_recommended_plugins', array());
            return $plumbing_contractor_plugins;
        }

        public function plumbing_contractor_get_plugin_buttion($slug, $name, $function) {
                $plumbing_contractor_is_done      = false;
                $plumbing_contractor_button_html  = '';
                $plumbing_contractor_is_installed = $this->is_plugin_installed($slug);
                $plumbing_contractor_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $plumbing_contractor_is_activeted = (class_exists($function)) ? true : false;
                if (!$plumbing_contractor_is_installed) {
                    $plumbing_contractor_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $plumbing_contractor_plugin_install_url = wp_nonce_url($plumbing_contractor_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $plumbing_contractor_button_html        = sprintf('<a class="plumbing-contractor-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($plumbing_contractor_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'plumbing-contractor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'plumbing-contractor')
                    );
                } elseif ($plumbing_contractor_is_installed && !$plumbing_contractor_is_activeted) {

                    $plumbing_contractor_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($plumbing_contractor_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $plumbing_contractor_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $plumbing_contractor_button_html = sprintf('<a class="plumbing-contractor-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($plumbing_contractor_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'plumbing-contractor'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'plumbing-contractor')
                    );
                } elseif ($plumbing_contractor_is_activeted) {
                    $plumbing_contractor_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'plumbing-contractor'));
                    $plumbing_contractor_is_done     = true;
                }

                return array('done' => $plumbing_contractor_is_done, 'button' => $plumbing_contractor_button_html);
            }
        public function is_plugin_installed($slug) {
            $plumbing_contractor_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $plumbing_contractor_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($plumbing_contractor_installed_plugins[$plumbing_contractor_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $plumbing_contractor_keys = array_keys($this->get_installed_plugins());
            foreach ($plumbing_contractor_keys as $plumbing_contractor_key) {
                if (preg_match('|^' . $slug . '/|', $plumbing_contractor_key)) {
                    return $plumbing_contractor_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
Plumbing_Contractor_Plugin_Activation_WPElemento_Importer::get_instance();